#include "hmg.ch"
* --------------------------------------------------------------*
FUNCTION SQL_Lov_Func( _ptable, _pfld1, _pfld2, _pwhere, _porder )
* --------------------------------------------------------------*
PRIVATE _Retval:='0', aTables:={}, aCurRows := {}
PRIVATE _table, _fld1, _fld2, _where, _order

_table := _ptable
_fld1 := _pfld1
_fld2 := _pfld2
_where := _pwhere
_order := _porder

if empty(_pwhere)
   _where := '%'
endif

   DEFINE WINDOW Lov_Form_sql ; 
      AT 0,0 ; 
      WIDTH 500 ; 
      HEIGHT 300 ; 
      TITLE "List of Value" ; 
      MODAL  

      @  10, 10 LABEL L1 ; 
         WIDTH 80 ; 
         HEIGHT 20 ; 
         VALUE "Search string:" 

     @  10, 100 Textbox WhatToSearch ; 
         WIDTH 95 ; 
         HEIGHT 20 ; 
         VALUE "%" UPPERCASE
                  
       @ 10, 200 BUTTON go ; 
         CAPTION "OK" ; 
         ACTION LoadSearch(2) ; 
         WIDTH 50 ; 
         HEIGHT 20 

      @ 40,20 GRID Lov_Grid_sql ; 
         WIDTH 450 ; 
         HEIGHT 200 ; 
         HEADERS { "Key", "Name" } ; 
         WIDTHS { 100, 300 } ; 
         VALUE 1 ; 
         ON DBLCLICK select_row_fns() 
                
   END WINDOW 

   LoadSearch(1) 
  
   CENTER WINDOW Lov_Form_sql
   ACTIVATE WINDOW Lov_Form_sql

RETURN _Retval 
* --------------------------------------------------------------*
FUNCTION select_row_fns()
* --------------------------------------------------------------*

   _Retval := GetColValue("Lov_Grid_sql", "Lov_Form_sql", 1 )
   Lov_Form_sql.Release 

RETURN _RetVal
* --------------------------------------------------------------*
FUNCTION LoadSearch( _pp )
* --------------------------------------------------------------*
LOCAL i:=0, oRow:={}, oQuery:=""

DELETE ITEM ALL FROM Lov_Grid_sql of Lov_Form_sql

if _pp = 2
   _where := rtrim(Lov_Form_sql.WhatToSearch.Value) 
endif

_sql := "SELECT " + _fld1 + ', ' + _fld2 + ' FROM ' + _table 
if !empty( _where)
   _sql := _sql + ' WHERE ' + _fld2 + ' LIKE ' + chr(39) + _where + chr(39)
endif

if !empty( _order )
   _sql := _sql + ' ORDER BY ' + _order
else
   _sql := _sql + ' ORDER BY ' + _fld2 
endif

aTables := sql( dbo, _sql ) 

_redova := len(aTables)

if _redova = 0
   msginfo('No data !')
   RELEASE WINDOW ALL 
   Quit 
endif

For i := 1 to len(aTables)
   aCurRows := aTables[i]
   ADD ITEM { str(aCurRows[1]), aCurRows[2] } TO Lov_Grid_sql Of Lov_Form_sql 
   
Next 

Lov_Form_sql.Lov_Grid_sql.SetFocus 

RETURN 0 
* -------------------------------------------------------------*
Function DToMy( xDate )
* -------------------------------------------------------------*
LOCAL cYear:= alltrim(str(  year( xDate )))
LOCAL cMon := alltrim(str( month( xDate )))
LOCAL cDay := alltrim(str(   day( xDate )))
LOCAL p1:='', p2:='' 
  
if len(cMon)  < 2
   p1 = '0'
endif
  
if len(cDay)  < 2
   p2 = '0'
endif
  
Return "'" + cYear + "-" + p1 + cMon + "-" + p2 + cDay + "'"
* -------------------------------------------------------------*
Function sql_dbname ( _dbname )
* -------------------------------------------------------------*
_full_dbname = alltrim(_dbname)

if at(',db3',_dbname) < 1 
   _full_dbname = alltrim(_dbname) + '.db3'
endif

Return _full_dbname
* --------------------------------------------------------------*
Function GetColValue( xObj, xForm, nCol)
* --------------------------------------------------------------*
LOCAL nPos:= GetProperty(xForm, xObj, 'Value')
LOCAL aRet:= GetProperty(xForm, xObj, 'Item', nPos)

Return aRet[nCol] 
* --------------------------------------------------------------*
FUNCTION year_start( )
* --------------------------------------------------------------*

   _dat = ctod('01.01.' + alltrim(str(year(date()))) )

RETURN _dat
* --------------------------------------------------------------*
FUNCTION year_end( )
* --------------------------------------------------------------*

   _dat = ctod('31.12.' + alltrim(str(year(date()))) )

RETURN _dat
* --------------------------------------------------------------*
FUNCTION Next_Val ( _ttt, _fff )
* --------------------------------------------------------------*
LOCAL i:=0, aRow:={}, _ret 

   _sql := "SELECT ifnull(max(" + _fff + "),0) FROM " + _ttt

   aTables := sql( dbo, _sql ) 

   _redova := len(aTables)

   if _redova = 0
      Return 1
   endif

   aRows := aTables[1]
   _ret = val(aRows[1]) + 1

RETURN _ret
* -----------------------------------------------------